----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:46:59 02/05/2008 
-- Design Name: 
-- Module Name:    counter - Behavioral 
-- Project Name: 
-- Target Devices: Spartan3E
-- Tool versions: ISE 9.2.04i
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity COUNTER_RST_CE is
	generic	(
					--Bitbreite des Zhlers
					BIT_WIDTH	:	positive := 4
				);
	port		(
					--Systemtakt
					CLK		: in	std_logic;
					--Synchroner Reseteingang (active high)
					RESET		: in	bit;
					--Clock enable (um den Zhler unter dem Systemtakt zu betreiben)
					CE			: in	bit;
					--Ausgang
					OUTPUT	: out	std_logic_vector((BIT_WIDTH - 1) downto 0) 
				);
end COUNTER_RST_CE;

architecture UP_COUNTER of COUNTER_RST_CE is

--Zhlvariable
signal COUNT_VAL : std_logic_vector((BIT_WIDTH - 1) downto 0);

begin

	process (CLK) 
	begin
		if rising_edge(CLK) then
			--Reset hat hchste Prioritt
			if RESET = '1' then
				--bei Reset die Zhlvariable zurcksetzen
				COUNT_VAL <= (others => '0');
			--nchste Priorittsstufe liegt beim clock enable
			elsif CE = '1' then
				--eine Stelle weiter zhlen
				COUNT_VAL <= COUNT_VAL + 1;
			end if;
		end if;
	end process; 
	
	--Die Zhlvariable auf den Ausgang abbilden
	OUTPUT <= COUNT_VAL;

end UP_COUNTER;
