----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    18:33:41 02/05/2008 
-- Design Name: 
-- Module Name:    COUNTER_RST_CE_CLR_EN - Behavioral 
-- Project Name: 
-- Target Devices: Spartan3E
-- Tool versions: ISE 9.2.04i
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity COUNTER_RST_CE_CLR_EN is
	generic	(
					--Bitbreite des Zhlers
					BIT_WIDTH	:	positive := 4
				);
	port		(
					--Systemtakt
					CLK		: in	std_logic;
					--Synchroner Reseteingang (active high)
					RESET		: in	bit;
					--Clock enable (um den Zhler unter dem Systemtakt zu betreiben)
					CE			: in	bit;
					--Systemtaktsynchroner clear- Eingang
					CLR		: in	bit;
					--Enable Eingang
					EN			: in	bit;
					--Ausgang
					OUTPUT	: out	std_logic_vector((BIT_WIDTH - 1) downto 0)
				);
end COUNTER_RST_CE_CLR_EN;

architecture UP_COUNTER of COUNTER_RST_CE_CLR_EN is

--Zhlvariable
signal COUNT_VAL : std_logic_vector((BIT_WIDTH - 1) downto 0);

begin

	process (CLK) 
	begin
		if rising_edge(CLK) then
			--Reset und clear haben hchste Prioritt
			if (RESET = '1') or (CLR = '1') then
				--Zhlvariable zurcksetzen
				COUNT_VAL <= (others => '0');
			--nchste Priorittsstufe liegt beim clock enable zusammen mit dem enable Signal
			elsif (CE = '1') and (EN = '1') then
				--Zhlen
				COUNT_VAL <= COUNT_VAL + 1;
			end if;
		end if;
	end process; 
	
	--Die Zhlvariable auf den Ausgang abbilden
	OUTPUT <= COUNT_VAL;

end UP_COUNTER;
