----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    22:12:20 02/06/2008 
-- Design Name: 
-- Module Name:    prescaler - Behavioral 
-- Project Name: 
-- Target Devices: Spartan3E
-- Tool versions: ISE 9.2.04i
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity PRESCALER is
	generic	(
					--Bitbreite des Prescalers
					BIT_WIDTH	: positive := 16
				);
	port		(
					--Systemtakt
					CLK				: in  std_logic;
					--Synchroner Reseteingang (active high)
					RESET				: in  bit;
					--Ausgang
					PRESCALER_OUT	: out  bit
				);
end PRESCALER;

architecture Behavioral of PRESCALER is

--Zhlvariable
signal	PRE_COUNT							: std_logic_vector(BIT_WIDTH downto 0);

begin

	CE_GENERATOR: process (CLK) 
	begin
		if rising_edge(CLK) then
			--Reset und clear haben hchste Prioritt
			if RESET = '1' then
				--Zhlvariable zurcksetzen
				PRE_COUNT <= (others => '0');
			--Ist das MSB gesetzt?
			elsif PRE_COUNT(BIT_WIDTH) = '1' then
				--Falls ja: Zhlvariable zurcksetzen und den Ausgang auf high
				PRE_COUNT <= (others => '0');
				PRESCALER_OUT <= '1';
			else
				--Falls nein: Zhlvariable inkrementieren und Ausgang auf low
				PRESCALER_OUT <= '0';
				PRE_COUNT <= PRE_COUNT + 1;
			end if;
		end if;
	end process CE_GENERATOR;
	
end Behavioral;

